#include <cairo.h>
#include <cairo-xlib.h>

static void
draw (cairo_t *cr);

int main (void)
{
    Display *dpy = XOpenDisplay (0);
    Window  w = XCreateSimpleWindow (dpy,
				     RootWindow (dpy, 0),
				     0, 0, WIDTH, HEIGHT,
				     0, 0, WhitePixel (dpy, 0));
    cairo_surface_t *surface = cairo_xlib_surface_create (dpy, w,
		        DefaultVisual (dpy, DefaultScreen (dpy)),
			 		          WIDTH, HEIGHT);
    XEvent  ev;
    XSelectInput (dpy, w, ExposureMask);
    XMapWindow (dpy, w);
    while (XNextEvent (dpy, &ev) == 0)
	if (ev.type == Expose && !ev.xexpose.count) {
	    cairo_t *cr = cairo_create (surface);
	    draw (cr);
	    cairo_destroy (cr);
	}
    return 0;
}
